blob: 07cc1f0c4ea8796de8a5b536f0555e4bbd13a3fc [file] [log] [blame]
Peter Stuge09377b72011-08-21 06:24:55 +02001#!/bin/sh
Stefan Reinauer074d9132009-09-26 16:43:17 +00002#
Stefan Reinauer5f1ad892010-05-17 11:02:25 +00003# Copyright (C) 2008-2010 by coresystems GmbH
Stefan Reinauer074d9132009-09-26 16:43:17 +00004# written by Patrick Georgi <patrick.georgi@coresystems.de> and
5# Stefan Reinauer <stefan.reinauer@coresystems.de>
Stefan Reinauer14e22772010-04-27 06:56:47 +00006#
Marc Jones2aac3f62011-08-08 16:07:50 -06007# Copyright (C) 2011 by Sage Electronic Engineering
8#
Stefan Reinauer074d9132009-09-26 16:43:17 +00009# This program is free software; you can redistribute it and/or modify
10# it under the terms of the GNU General Public License as published by
11# the Free Software Foundation; version 2 of the License.
12#
13# This program is distributed in the hope that it will be useful,
14# but WITHOUT ANY WARRANTY; without even the implied warranty of
15# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
16# GNU General Public License for more details.
17#
18# You should have received a copy of the GNU General Public License
19# along with this program; if not, write to the Free Software
Paul Menzela46a7122013-02-23 18:37:27 +010020# Foundation, Inc., 51 Franklin Street, Suite 500, Boston, MA 02110-1335, USA
Stefan Reinauer074d9132009-09-26 16:43:17 +000021#
22
Patrick Georgi8135dba2015-03-17 21:05:20 +010023cd `dirname $0`
24
Patrick Georgi53c388f2015-03-07 09:55:18 +010025CROSSGCC_DATE="March 8th, 2015"
26CROSSGCC_VERSION="1.27"
Stefan Reinauer074d9132009-09-26 16:43:17 +000027
28# default settings
29TARGETDIR=`pwd`/xgcc
30TARGETARCH=i386-elf
31DESTDIR=
32
33# version numbers
Patrick Georgi53c388f2015-03-07 09:55:18 +010034GMP_VERSION=6.0.0
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070035MPFR_VERSION=3.1.2
Paul Menzele6619422015-02-23 10:33:59 +010036MPC_VERSION=1.0.3
Stefan Reinauer5f1ad892010-05-17 11:02:25 +000037LIBELF_VERSION=0.8.13
Patrick Georgi53c388f2015-03-07 09:55:18 +010038GCC_VERSION=4.9.2
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070039GCC_AUTOCONF_VERSION=2.69
Patrick Georgi53c388f2015-03-07 09:55:18 +010040BINUTILS_VERSION=2.25
41GDB_VERSION=7.9
42IASL_VERSION=20150204
43PYTHON_VERSION=3.4.3
Idwer Vollering296a0152012-10-26 01:48:04 +020044EXPAT_VERSION=2.1.0
Stefan Reinauer074d9132009-09-26 16:43:17 +000045
46# archive locations
Patrick Georgi53c388f2015-03-07 09:55:18 +010047GMP_ARCHIVE="http://ftpmirror.gnu.org/gmp/gmp-${GMP_VERSION}a.tar.bz2"
Patrick Georgi6e61ad32012-05-12 23:19:30 +020048MPFR_ARCHIVE="http://ftpmirror.gnu.org/mpfr/mpfr-${MPFR_VERSION}.tar.bz2"
Idwer Vollering7962fc72012-10-25 02:14:09 +020049MPC_ARCHIVE="http://ftpmirror.gnu.org/mpc/mpc-${MPC_VERSION}.tar.gz"
Stefan Reinauer5f1ad892010-05-17 11:02:25 +000050LIBELF_ARCHIVE="http://www.mr511.de/software/libelf-${LIBELF_VERSION}.tar.gz"
Idwer Vollering1cfee0b2012-10-25 02:03:53 +020051GCC_ARCHIVE="http://ftpmirror.gnu.org/gcc/gcc-${GCC_VERSION}/gcc-${GCC_VERSION}.tar.bz2"
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070052BINUTILS_ARCHIVE="http://ftpmirror.gnu.org/binutils/binutils-${BINUTILS_VERSION}.tar.bz2"
Patrick Georgi53c388f2015-03-07 09:55:18 +010053GDB_ARCHIVE="http://ftpmirror.gnu.org/gdb/gdb-${GDB_VERSION}.tar.xz"
54IASL_ARCHIVE="https://acpica.org/sites/acpica/files/acpica-unix-${IASL_VERSION}.tar.gz"
55PYTHON_ARCHIVE="http://www.python.org/ftp/python/${PYTHON_VERSION}/Python-${PYTHON_VERSION}.tar.xz"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +010056EXPAT_ARCHIVE="http://downloads.sourceforge.net/sourceforge/expat/expat-${EXPAT_VERSION}.tar.gz"
Stefan Reinauer074d9132009-09-26 16:43:17 +000057
58GMP_DIR="gmp-${GMP_VERSION}"
59MPFR_DIR="mpfr-${MPFR_VERSION}"
Stefan Reinauer5f1ad892010-05-17 11:02:25 +000060MPC_DIR="mpc-${MPC_VERSION}"
61LIBELF_DIR="libelf-${LIBELF_VERSION}"
Stefan Reinauer074d9132009-09-26 16:43:17 +000062GCC_DIR="gcc-${GCC_VERSION}"
63BINUTILS_DIR="binutils-${BINUTILS_VERSION}"
64GDB_DIR="gdb-${GDB_VERSION}"
Marc Jones2aac3f62011-08-08 16:07:50 -060065IASL_DIR="acpica-unix-${IASL_VERSION}"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +010066PYTHON_DIR="Python-${PYTHON_VERSION}"
67EXPAT_DIR="expat-${EXPAT_VERSION}"
Stefan Reinauer074d9132009-09-26 16:43:17 +000068
Patrick Georgi6321f522015-02-27 23:36:26 +010069unset MAKELEVEL MAKEFLAGS
70
Stefan Reinauer074d9132009-09-26 16:43:17 +000071SAVETEMPS=0
Stefan Reinauer2c3cd122011-11-01 21:43:50 +010072SKIPGDB=1
73SKIPPYTHON=1
Stefan Reinauer074d9132009-09-26 16:43:17 +000074
Patrick Georgi1861ff72011-10-31 12:15:55 +010075red='\033[0;31m'
76RED='\033[1;31m'
77green='\033[0;32m'
78GREEN='\033[1;32m'
79blue='\033[0;34m'
80BLUE='\033[1;34m'
81cyan='\033[0;36m'
82CYAN='\033[1;36m'
83NC='\033[0m' # No Color
Stefan Reinauer074d9132009-09-26 16:43:17 +000084
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070085UNAME=`uname`
86
Patrick Georgi198d23c2012-12-08 08:02:44 +010087normalize_dirs()
88{
89 mkdir -p $DESTDIR$TARGETDIR/lib
90 test -d $DESTDIR$TARGETDIR/lib32 && mv $DESTDIR$TARGETDIR/lib32/* $DESTDIR$TARGETDIR/lib
91 test -d $DESTDIR$TARGETDIR/lib64 && mv $DESTDIR$TARGETDIR/lib64/* $DESTDIR$TARGETDIR/lib
92 rmdir -p $DESTDIR$TARGETDIR/lib32 $DESTDIR$TARGETDIR/lib64
93
94 perl -pi -e "s,/lib32,/lib," $DESTDIR$TARGETDIR/lib/*.la
95 perl -pi -e "s,/lib64,/lib," $DESTDIR$TARGETDIR/lib/*.la
96}
97
Patrick Georgib7062882015-02-24 10:52:14 +010098searchtool()
Stefan Reinauer074d9132009-09-26 16:43:17 +000099{
100 # $1 short name
Patrick Georgib7062882015-02-24 10:52:14 +0100101 # $2 search string
102 # $3 soft fail if set
103 # result: file name of that tool on stdout
104 # or no output if nothing suitable was found
105 search=GNU
106 if [ -n "$2" ]; then
107 search="$2"
108 fi
Stefan Reinauer074d9132009-09-26 16:43:17 +0000109 for i in "$1" "g$1" "gnu$1"; do
110 if test -x "`which $i 2>/dev/null`"; then
Patrick Georgib7062882015-02-24 10:52:14 +0100111 if test `$i --version 2>/dev/null |grep -c "$search"` \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100112 -gt 0; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000113 echo $i
114 return
115 fi
116 fi
117 done
Andrew Wub67e9a12014-04-28 18:13:44 +0800118 # A workaround for OSX 10.9 and some BSDs, whose nongnu
119 # patch and tar also work.
120 if [ $UNAME = "Darwin" -o $UNAME = "FreeBSD" -o $UNAME = "NetBSD" ]; then
Patrick Georgib7062882015-02-24 10:52:14 +0100121 if [ "$1" = "patch" -o "$1" = "tar" ]; then
Zheng Bao36156ff2012-09-28 16:18:58 +0800122 if test -x "`which $1 2>/dev/null`"; then
123 echo $1
124 return
125 fi
126 fi
127 fi
Stefan Reinauer074d9132009-09-26 16:43:17 +0000128 printf "${RED}ERROR:${red} Missing toolchain: $1${NC}\n" >&2
Patrick Georgib7062882015-02-24 10:52:14 +0100129 [ -z "$3" ] && exit 1
130 false
Stefan Reinauer074d9132009-09-26 16:43:17 +0000131}
132
Patrick Georgib7062882015-02-24 10:52:14 +0100133TAR=`searchtool tar` || exit $?
134PATCH=`searchtool patch` || exit $?
135MAKE=`searchtool make` || exit $?
Stefan Reinauer074d9132009-09-26 16:43:17 +0000136
Patrick Georgib7062882015-02-24 10:52:14 +0100137searchtool m4 > /dev/null
138searchtool bison > /dev/null
139searchtool flex flex > /dev/null
140searchtool g++ "Free Software Foundation" nofail > /dev/null || \
141searchtool clang "clang version"
Patrick Georgi5fb2b5c2012-05-12 23:25:23 +0200142
Stefan Reinauer074d9132009-09-26 16:43:17 +0000143cleanup()
144{
145 printf "Cleaning up temporary files... "
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200146 rm -rf ${BUILDDIRPREFIX}-* combined gcc-* gmp-* mpfr-* mpc-* libelf-* binutils-*
Patrick Georgi969cd932012-12-07 13:13:53 +0100147 rm -rf gdb-* acpica-* python-* expat-*
Stefan Reinauer074d9132009-09-26 16:43:17 +0000148 printf "${green}ok${NC}\n"
149}
150
151myhelp()
152{
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100153 printf "Usage: $0 [-V] [-c] [-p <platform>] [-d <target directory>] [-D <dest dir>] [-G] [-S]\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000154 printf " $0 [-V|--version]\n"
155 printf " $0 [-h|--help]\n\n"
156
157 printf "Options:\n"
158 printf " [-V|--version] print version number and exit\n"
159 printf " [-h|--help] print this help and exit\n"
160 printf " [-c|--clean] remove temporary files before build\n"
161 printf " [-t|--savetemps] don't remove temporary files after build\n"
Patrick Georgic1a75b12011-11-04 21:37:14 +0100162 printf " [-y|--ccache] Use ccache when building cross compiler\n"
Patrick Georgi73166c72010-04-14 20:42:42 +0000163 printf " [-j|--jobs <num>] run <num> jobs in parallel in make\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000164 printf " [-p|--platform <platform>] target platform to build cross compiler for\n"
165 printf " (defaults to $TARGETARCH)\n"
166 printf " [-d|--directory <target dir>] target directory to install cross compiler to\n"
167 printf " (defaults to $TARGETDIR)\n\n"
168 printf " [-D|--destdir <dest dir>] destination directory to install cross compiler to\n"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100169 printf " (for RPM builds, default unset)\n"
170 printf " [-G|--gdb] build GNU debugger\n"
171 printf " [-S|--scripting] build scripting support for GDB\n\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000172}
173
174myversion()
175{
176 # version tag is always printed, so just print the license here
177
178 cat << EOF
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000179Copyright (C) 2008-2010 by coresystems GmbH
Marc Jones2aac3f62011-08-08 16:07:50 -0600180Copyright (C) 2011 by Sage Electronic Engineering
Stefan Reinauer074d9132009-09-26 16:43:17 +0000181
182This program is free software; you can redistribute it and/or modify
183it under the terms of the GNU General Public License as published by
184the Free Software Foundation; version 2 of the License.
185
186This program is distributed in the hope that it will be useful,
187but WITHOUT ANY WARRANTY; without even the implied warranty of
188MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
189GNU General Public License for more details.
190
191EOF
192}
193
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700194printf "${blue}Welcome to the ${red}coreboot${blue} cross toolchain builder v$CROSSGCC_VERSION ($CROSSGCC_DATE)${NC}\n\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000195
Patrick Georgi6bba29f2010-01-29 17:40:52 +0000196# Look if we have getopt. If not, build it.
197export PATH=$PATH:.
198getopt - > /dev/null 2>/dev/null || gcc -o getopt getopt.c
199
Stefan Reinauer074d9132009-09-26 16:43:17 +0000200# parse parameters.. try to find out whether we're running GNU getopt
Peter Stuge09377b72011-08-21 06:24:55 +0200201getoptbrand="`getopt -V | sed -e '1!d' -e 's,^\(......\).*,\1,'`"
202if [ "${getoptbrand}" = "getopt" ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000203 # Detected GNU getopt that supports long options.
Patrick Georgic1a75b12011-11-04 21:37:14 +0100204 args=`getopt -l version,help,clean,directory:,platform:,jobs:,destdir:,savetemps,skip-gdb,ccache Vhcd:p:j:D:tGy -- "$@"`
Stefan Reinauer074d9132009-09-26 16:43:17 +0000205 eval set "$args"
206else
207 # Detected non-GNU getopt
Patrick Georgic1a75b12011-11-04 21:37:14 +0100208 args=`getopt Vhcd:p:j:D:tGy $*`
Stefan Reinauer074d9132009-09-26 16:43:17 +0000209 set -- $args
210fi
211
212if [ $? != 0 ]; then
213 myhelp
214 exit 1
215fi
216
217while true ; do
218 case "$1" in
219 -V|--version) shift; myversion; exit 0;;
220 -h|--help) shift; myhelp; exit 0;;
Patrick Georgi44af57a2013-12-19 22:06:22 +0100221 -c|--clean) shift; clean=1;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000222 -t|--savetemps) shift; SAVETEMPS=1;;
223 -d|--directory) shift; TARGETDIR="$1"; shift;;
224 -p|--platform) shift; TARGETARCH="$1"; shift;;
225 -D|--destdir) shift; DESTDIR="$1"; shift;;
Patrick Georgi73166c72010-04-14 20:42:42 +0000226 -j|--jobs) shift; JOBS="-j $1"; shift;;
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100227 -G|--gdb) shift; SKIPGDB=0;;
228 -S|--scripting) shift; SKIPPYTHON=0;;
Patrick Georgic1a75b12011-11-04 21:37:14 +0100229 -y|--ccache) shift; USECCACHE=1;;
Patrick Georgid2e0dd52013-06-09 08:05:45 +0200230 --) shift; break;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000231 -*) printf "Invalid option\n\n"; myhelp; exit 1;;
Patrick Georgid2e0dd52013-06-09 08:05:45 +0200232 *) break;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000233 esac
234done
235
Ronald G. Minnichb460a662013-05-26 05:33:35 -0700236case "$TARGETARCH" in
Stefan Reinauer24f9cb92015-03-13 22:50:22 +0100237 x86_64-elf) ;;
238 x86_64*) TARGETARCH=x86_64-elf;;
David Hubbard5b0420a2013-05-28 16:33:15 -0600239 i386-elf) ;;
240 i386-mingw32) ;;
Patrick Georgi9b7efa52015-03-08 09:20:36 +0100241 mipsel-elf) ;;
Patrick Georgif0bbc952015-03-07 10:57:25 +0100242 riscv-elf) ;;
Ronald G. Minnichb460a662013-05-26 05:33:35 -0700243 i386*) TARGETARCH=i386-elf;;
Patrick Georgic8883262013-09-19 10:57:58 +0200244 arm*) TARGETARCH=armv7-a-eabi;;
Stefan Reinauer0d2119d2013-07-10 14:27:56 -0700245 aarch64*) TARGETARCH=aarch64-elf;;
246 *) printf "${red}WARNING: Unsupported architecture $TARGETARCH.${NC}\n\n"; ;;
Ronald G. Minnichb460a662013-05-26 05:33:35 -0700247esac
248
249echo "Target arch is now $TARGETARCH"
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200250BUILDDIRPREFIX=build-${TARGETARCH}
251
Patrick Georgi44af57a2013-12-19 22:06:22 +0100252if [ "$clean" = "1" ]; then
253 cleanup
254fi
255
Peter Stugeceacd772011-06-09 04:54:16 +0200256GDB_PACKAGE="GDB"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100257PYTHON_PACKAGE="PYTHON"
258EXPAT_PACKAGE="EXPAT"
Peter Stugeceacd772011-06-09 04:54:16 +0200259if [ $SKIPGDB -eq 1 ]; then
260 printf "Will skip GDB ... ${green}ok${NC}\n"
Peter Stuge0e8ee812011-08-28 11:04:23 +0200261 GDB_ARCHIVE=""
Peter Stugeceacd772011-06-09 04:54:16 +0200262 GDB_PACKAGE=""
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100263 if [ $SKIPPYTHON -eq 0 ]; then
264 printf "Python scripting needs GDB ... disabling ... ${green}ok${NC}\n"
265 SKIPPYTHON=1
266 fi
267fi
268if [ $SKIPPYTHON -eq 1 ]; then
Jonathan A. Kollasch2d7ab4c2011-11-07 13:05:18 -0600269 PYTHON_ARCHIVE=""
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100270 PYTHON_PACKAGE=""
Jonathan A. Kollasch2d7ab4c2011-11-07 13:05:18 -0600271 EXPAT_ARCHIVE=""
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100272 EXPAT_PACKAGE=""
Peter Stugeceacd772011-06-09 04:54:16 +0200273fi
274
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700275# coreboot does not like the GOLD linker
276# USE_GOLD="--enable-gold"
277USE_GOLD=""
278GCC_OPTIONS="--enable-lto"
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000279
Stefan Reinauer074d9132009-09-26 16:43:17 +0000280printf "Downloading tar balls ... \n"
281mkdir -p tarballs
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100282for ARCHIVE in $GMP_ARCHIVE $MPFR_ARCHIVE $MPC_ARCHIVE $LIBELF_ARCHIVE \
Patrick Georgi969cd932012-12-07 13:13:53 +0100283 $GCC_ARCHIVE $BINUTILS_ARCHIVE $GDB_ARCHIVE \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100284 $IASL_ARCHIVE $PYTHON_ARCHIVE $EXPAT_ARCHIVE; do
Stefan Reinauer074d9132009-09-26 16:43:17 +0000285 FILE=`basename $ARCHIVE`
286 printf " * $FILE "
287 test -f tarballs/$FILE && printf "(cached)" || (
288 printf "(downloading)"
289 cd tarballs
Patrick Georgi6e61ad32012-05-12 23:19:30 +0200290 wget --no-check-certificate -q $ARCHIVE
Stefan Reinauer074d9132009-09-26 16:43:17 +0000291 )
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100292 test -f tarballs/$FILE || \
Zheng Bao5b209c02012-09-20 16:09:51 +0800293 printf "\n${RED}Failed to download $FILE.${NC}\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000294 test -f tarballs/$FILE || exit 1
295 printf "\n"
296done
297printf "Downloaded tar balls ... "
298printf "${green}ok${NC}\n"
299
300printf "Unpacking and patching ... \n"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100301for PACKAGE in GMP MPFR MPC LIBELF GCC BINUTILS $PYTHON_PACKAGE \
Patrick Georgi969cd932012-12-07 13:13:53 +0100302 $EXPAT_PACKAGE $GDB_PACKAGE IASL; do
Stefan Reinauer074d9132009-09-26 16:43:17 +0000303 archive=$PACKAGE"_ARCHIVE"
Peter Stuge09377b72011-08-21 06:24:55 +0200304 archive="`eval echo '$'$archive`"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000305 dir=$PACKAGE"_DIR"
Peter Stuge09377b72011-08-21 06:24:55 +0200306 dir="`eval echo '$'${dir}`"
Zheng Baof95bb2d2013-12-13 12:30:46 +0800307 test -d ${dir} && test -f ${dir}/.unpack_success || (
Stefan Reinauer074d9132009-09-26 16:43:17 +0000308 printf " * `basename $archive`\n"
309 FLAGS=zxf
Peter Stuge09377b72011-08-21 06:24:55 +0200310 suffix=`echo $archive | sed 's,.*\.,,'`
311 test "$suffix" = "gz" && FLAGS=zxf
312 test "$suffix" = "bz2" && FLAGS=jxf
Patrick Georgi53c388f2015-03-07 09:55:18 +0100313 test "$suffix" = "xz" && FLAGS="--xz -xf"
Peter Stuge09377b72011-08-21 06:24:55 +0200314 test "$suffix" = "lzma" && FLAGS="--lzma -xf"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000315 $TAR $FLAGS tarballs/`basename $archive`
Peter Stuge09377b72011-08-21 06:24:55 +0200316 for patch in patches/${dir}_*.patch; do
Stefan Reinauer074d9132009-09-26 16:43:17 +0000317 test -r $patch || continue
318 printf " o `basename $patch`\n"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100319 $PATCH -s -N -p0 < `echo $patch` || \
Zheng Bao5b209c02012-09-20 16:09:51 +0800320 printf "\n${RED}Failed $patch.${NC}\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000321 done
Zheng Bao691b313c2013-12-09 14:09:07 +0800322 touch ${dir}/.unpack_success
Stefan Reinauer074d9132009-09-26 16:43:17 +0000323 )
324done
325printf "Unpacked and patched ... "
326printf "${green}ok${NC}\n"
327
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700328CC=cc
Stefan Reinauer0d2119d2013-07-10 14:27:56 -0700329if [ $UNAME = "Darwin" ]; then
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000330 #GCC_OPTIONS="$GCC_OPTIONS --enable-threads=posix"
331
332 # generally the OS X compiler can create x64 binaries.
333 # Per default it generated i386 binaries in 10.5 and x64
334 # binaries in 10.6 (even if the kernel is 32bit)
335 # For some weird reason, 10.5 autodetects an ABI=64 though
336 # so we're setting the ABI explicitly here.
Zheng Bao04ceed62012-10-23 19:41:25 +0800337 if [ `sysctl -n hw.optional.x86_64 2>/dev/null` -eq 1 ] 2>/dev/null; then
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000338 OPTIONS="ABI=64"
339 else
340 OPTIONS="ABI=32"
341 fi
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700342
Stefan Reinauer4266b922012-12-05 16:18:32 -0800343 # In Xcode 4.5.2 the default compiler is clang.
344 # However, this compiler fails to compile gcc 4.7.x. As a
345 # workaround it's possible to compile gcc with llvm-gcc.
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700346 if $CC -v 2>&1 | grep -q LLVM; then
Stefan Reinauer4266b922012-12-05 16:18:32 -0800347 CC=llvm-gcc
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700348 fi
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000349fi
350
Patrick Georgic1a75b12011-11-04 21:37:14 +0100351if [ "$USECCACHE" = 1 ]; then
352 CC="ccache $CC"
353fi
354
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200355mkdir -p ${BUILDDIRPREFIX}-gmp ${BUILDDIRPREFIX}-mpfr ${BUILDDIRPREFIX}-mpc ${BUILDDIRPREFIX}-libelf ${BUILDDIRPREFIX}-binutils \
356 ${BUILDDIRPREFIX}-gcc ${BUILDDIRPREFIX}-python ${BUILDDIRPREFIX}-expat
Stefan Reinauer16bd7892012-12-07 23:57:01 +0100357
358mkdir -p $DESTDIR$TARGETDIR/bin
359export PATH=$DESTDIR$TARGETDIR/bin:$PATH
360
Peter Stugeceacd772011-06-09 04:54:16 +0200361if [ $SKIPGDB -eq 0 ]; then
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200362 mkdir -p ${BUILDDIRPREFIX}-gdb
Peter Stugeceacd772011-06-09 04:54:16 +0200363fi
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200364if [ -f ${BUILDDIRPREFIX}-gmp/.success ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000365 printf "Skipping GMP as it is already built\n"
366else
367printf "Building GMP ${GMP_VERSION} ... "
368(
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200369 cd ${BUILDDIRPREFIX}-gmp
Stefan Reinauer074d9132009-09-26 16:43:17 +0000370 rm -f .failed
Patrick Georgi643c9e82011-11-04 21:30:49 +0100371 CC="$CC" ../${GMP_DIR}/configure --disable-shared --prefix=$TARGETDIR $OPTIONS \
Stefan Reinauer074d9132009-09-26 16:43:17 +0000372 || touch .failed
Patrick Georgi73166c72010-04-14 20:42:42 +0000373 $MAKE $JOBS || touch .failed
Stefan Reinauer074d9132009-09-26 16:43:17 +0000374 $MAKE install DESTDIR=$DESTDIR || touch .failed
Patrick Georgi198d23c2012-12-08 08:02:44 +0100375
376 normalize_dirs
377
Stefan Reinauer074d9132009-09-26 16:43:17 +0000378 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200379) > ${BUILDDIRPREFIX}-gmp/crossgcc-build.log 2>&1
380test -r ${BUILDDIRPREFIX}-gmp/.failed && printf "${RED}failed${NC}\n" || \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100381 printf "${green}ok${NC}\n"
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200382test -r ${BUILDDIRPREFIX}-gmp/.failed && exit 1
Stefan Reinauer074d9132009-09-26 16:43:17 +0000383fi
384
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700385# Now set CFLAGS to match GMP CFLAGS but strip out -pedantic
386# as GCC 4.6.x fails if it's there.
387HOSTCFLAGS=`grep __GMP_CFLAGS $DESTDIR$TARGETDIR/include/gmp.h |cut -d\" -f2 |\
388 sed s,-pedantic,,`
Stefan Reinauer074d9132009-09-26 16:43:17 +0000389
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200390if [ -f ${BUILDDIRPREFIX}-mpfr/.success ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000391 printf "Skipping MPFR as it is already built\n"
392else
393printf "Building MPFR ${MPFR_VERSION} ... "
394(
Stefan Reinauer0d2119d2013-07-10 14:27:56 -0700395 test $UNAME = "Darwin" && CFLAGS="$CFLAGS -force_cpusubtype_ALL"
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200396 cd ${BUILDDIRPREFIX}-mpfr
Stefan Reinauer074d9132009-09-26 16:43:17 +0000397 rm -f .failed
Patrick Georgi643c9e82011-11-04 21:30:49 +0100398 CC="$CC" ../${MPFR_DIR}/configure --disable-shared --prefix=$TARGETDIR \
Stefan Reinauer074d9132009-09-26 16:43:17 +0000399 --infodir=$TARGETDIR/info \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100400 --with-gmp=$DESTDIR$TARGETDIR CFLAGS="$HOSTCFLAGS" || \
401 touch .failed
Patrick Georgi73166c72010-04-14 20:42:42 +0000402 $MAKE $JOBS || touch .failed
Stefan Reinauer074d9132009-09-26 16:43:17 +0000403 $MAKE install DESTDIR=$DESTDIR || touch .failed
404
Patrick Georgi198d23c2012-12-08 08:02:44 +0100405 normalize_dirs
406
Stefan Reinauer074d9132009-09-26 16:43:17 +0000407 # work around build problem of libgmp.la
408 if [ "$DESTDIR" != "" ]; then
409 perl -pi -e "s,$DESTDIR,," $DESTDIR$TARGETDIR/libgmp.la
410 fi
411
412 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200413) > ${BUILDDIRPREFIX}-mpfr/crossgcc-build.log 2>&1
414test -r ${BUILDDIRPREFIX}-mpfr/.failed && printf "${RED}failed${NC}\n" || \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100415 printf "${green}ok${NC}\n"
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200416test -r ${BUILDDIRPREFIX}-mpfr/.failed && exit 1
Stefan Reinauer074d9132009-09-26 16:43:17 +0000417fi
418
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200419if [ -f ${BUILDDIRPREFIX}-mpc/.success ]; then
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000420 printf "Skipping MPC as it is already built\n"
421else
422printf "Building MPC ${MPC_VERSION} ... "
423(
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200424 cd ${BUILDDIRPREFIX}-mpc
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000425 rm -f .failed
Patrick Georgi643c9e82011-11-04 21:30:49 +0100426 CC="$CC" ../${MPC_DIR}/configure --disable-shared --prefix=$TARGETDIR \
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000427 --infodir=$TARGETDIR/info --with-mpfr=$DESTDIR$TARGETDIR \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100428 --with-gmp=$DESTDIR$TARGETDIR CFLAGS="$HOSTCFLAGS" || \
429 touch .failed
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000430 $MAKE $JOBS || touch .failed
431 $MAKE install DESTDIR=$DESTDIR || touch .failed
432
Patrick Georgi198d23c2012-12-08 08:02:44 +0100433 normalize_dirs
434
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000435 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200436) > ${BUILDDIRPREFIX}-mpc/crossgcc-build.log 2>&1
437test -r ${BUILDDIRPREFIX}-mpc/.failed && printf "${RED}failed${NC}\n" || \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100438 printf "${green}ok${NC}\n"
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200439test -r ${BUILDDIRPREFIX}-mpc/.failed && exit 1
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000440fi
441
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200442if [ -f ${BUILDDIRPREFIX}-libelf/.success ]; then
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000443 printf "Skipping libelf as it is already built\n"
444else
445printf "Building libelf ${LIBELF_VERSION} ... "
446(
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200447 cd ${BUILDDIRPREFIX}-libelf
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000448 rm -f .failed
449 echo "$HOSTCFLAGS"
Patrick Georgi643c9e82011-11-04 21:30:49 +0100450 CC="$CC" CFLAGS="$HOSTCFLAGS" libelf_cv_elf_h_works=no \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100451 ../${LIBELF_DIR}/configure --disable-shared --prefix=$TARGETDIR \
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000452 --infodir=$TARGETDIR/info CFLAGS="$HOSTCFLAGS" || touch .failed
453 $MAKE $JOBS || touch .failed
Scott Duplichan4270a972014-12-12 20:21:40 -0600454 $MAKE install prefix=$DESTDIR$TARGETDIR || touch .failed
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000455
Patrick Georgi198d23c2012-12-08 08:02:44 +0100456 normalize_dirs
457
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000458 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200459) > ${BUILDDIRPREFIX}-libelf/crossgcc-build.log 2>&1
460test -r ${BUILDDIRPREFIX}-libelf/.failed && printf "${RED}failed${NC}\n" || \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100461 printf "${green}ok${NC}\n"
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200462test -r ${BUILDDIRPREFIX}-libelf/.failed && exit 1
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000463fi
464
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200465if [ -f ${BUILDDIRPREFIX}-binutils/.success ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000466 printf "Skipping binutils as it is already built\n"
467else
468printf "Building binutils ${BINUTILS_VERSION} ... "
469(
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700470 # What a pain: binutils don't come with configure
471 # script anymore. Create it:
472 cd binutils-${BINUTILS_VERSION}/
473 autoconf
474 cd ..
475 # Now build binutils
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200476 cd ${BUILDDIRPREFIX}-binutils
Stefan Reinauer074d9132009-09-26 16:43:17 +0000477 rm -f .failed
Patrick Georgi643c9e82011-11-04 21:30:49 +0100478 CC="$CC" ../binutils-${BINUTILS_VERSION}/configure --prefix=$TARGETDIR \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100479 --target=${TARGETARCH} --disable-werror --disable-nls \
480 $USE_GOLD CFLAGS="$HOSTCFLAGS" || touch .failed
Patrick Georgi73166c72010-04-14 20:42:42 +0000481 $MAKE $JOBS || touch .failed
Stefan Reinauer074d9132009-09-26 16:43:17 +0000482 $MAKE install DESTDIR=$DESTDIR || touch .failed
483 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200484) > ${BUILDDIRPREFIX}-binutils/crossgcc-build.log 2>&1
485test -r ${BUILDDIRPREFIX}-binutils/.failed && printf "${RED}failed${NC}\n" || \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100486 printf "${green}ok${NC}\n"
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200487test -r ${BUILDDIRPREFIX}-binutils/.failed && exit 1
Stefan Reinauer074d9132009-09-26 16:43:17 +0000488fi
489
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200490if [ -f ${BUILDDIRPREFIX}-gcc/.success ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000491 printf "Skipping GCC as it is already built\n"
492else
493printf "Building GCC ${GCC_VERSION} ... "
494(
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700495 # Even worse than binutils: GCC does not come with configure
496 # script anymore, but also enforces an obsolete autoconf version
497 # to create it. This is a poster child of how autotools help make
498 # software portable.
499 cd gcc-${GCC_VERSION}
500 sed '/dnl Ensure exactly this Autoconf version is used/d' \
501 config/override.m4 > config/override.m4.new
502 autoconf_version=`autoconf -V | grep "autoconf" | tr ' ' '\n' | tail -1`
503 sed "s/${GCC_AUTOCONF_VERSION}/${autoconf_version}/g" \
504 config/override.m4.new > config/override.m4
505 autoconf
506 cd ..
507 # Now, finally, we can build gcc:
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200508 cd ${BUILDDIRPREFIX}-gcc
Stefan Reinauer074d9132009-09-26 16:43:17 +0000509 rm -f .failed
510 # GCC does not honour HOSTCFLAGS at all. CFLAGS are used for
511 # both target and host object files. This is pretty misdesigned.
512 # There's a work-around called CFLAGS_FOR_BUILD and CFLAGS_FOR_TARGET
513 # but it does not seem to work properly. At least the host library
514 # libiberty is not compiled with CFLAGS_FOR_BUILD.
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700515 CC="$CC" CFLAGS_FOR_TARGET="-O2" CFLAGS="$HOSTCFLAGS" \
516 CFLAGS_FOR_BUILD="$HOSTCFLAGS" ../gcc-${GCC_VERSION}/configure \
Stefan Reinauer074d9132009-09-26 16:43:17 +0000517 --prefix=$TARGETDIR --libexecdir=$TARGETDIR/lib \
Stefan Reinauer6ade1612010-01-16 16:44:20 +0000518 --target=${TARGETARCH} --disable-werror --disable-shared \
Stefan Reinauer074d9132009-09-26 16:43:17 +0000519 --disable-libssp --disable-bootstrap --disable-nls \
Patrick Georgi969cd932012-12-07 13:13:53 +0100520 --disable-libquadmath --without-headers \
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000521 $GCC_OPTIONS --enable-languages="c" $USE_GOLD \
Stefan Reinauer074d9132009-09-26 16:43:17 +0000522 --with-gmp=$DESTDIR$TARGETDIR --with-mpfr=$DESTDIR$TARGETDIR \
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000523 --with-mpc=$DESTDIR$TARGETDIR --with-libelf=$DESTDIR$TARGETDIR \
524 --with-pkgversion="coreboot toolchain v$CROSSGCC_VERSION $CROSSGCC_DATE" \
Stefan Reinauer074d9132009-09-26 16:43:17 +0000525 || touch .failed
Patrick Georgi969cd932012-12-07 13:13:53 +0100526 $MAKE $JOBS CFLAGS_FOR_BUILD="$HOSTCFLAGS" all-gcc || touch .failed
527 $MAKE install-gcc DESTDIR=$DESTDIR || touch .failed
528
529 if [ "`echo $TARGETARCH | grep -c -- -mingw32`" -eq 0 ]; then
530 $MAKE $JOBS CFLAGS_FOR_BUILD="$HOSTCFLAGS" all-target-libgcc || touch .failed
531 $MAKE install-target-libgcc DESTDIR=$DESTDIR || touch .failed
532 fi
533
Stefan Reinauer074d9132009-09-26 16:43:17 +0000534 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200535) > ${BUILDDIRPREFIX}-gcc/crossgcc-build.log 2>&1
536test -r ${BUILDDIRPREFIX}-gcc/.failed && printf "${RED}failed${NC}\n" || \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100537 printf "${green}ok${NC}\n"
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200538test -r ${BUILDDIRPREFIX}-gcc/.failed && exit 1
Stefan Reinauer074d9132009-09-26 16:43:17 +0000539fi
540
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200541if [ -f ${BUILDDIRPREFIX}-expat/.success ]; then
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100542 printf "Skipping Expat as it is already built\n"
Stefan Reinauer1200ec52011-11-01 22:39:41 +0100543elif [ $SKIPPYTHON -eq 1 ]; then
544 printf "Skipping Expat (Python scripting not enabled)\n"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100545else
546printf "Building Expat ${EXPAT_VERSION} ... "
547(
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200548 cd ${BUILDDIRPREFIX}-expat
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100549 rm -f .failed
Patrick Georgi643c9e82011-11-04 21:30:49 +0100550 CC="$CC" CFLAGS="$HOSTCFLAGS" ../${EXPAT_DIR}/configure --disable-shared \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100551 --prefix=$TARGETDIR --target=${TARGETARCH} || touch .failed
552 $MAKE || touch .failed
553 $MAKE install DESTDIR=$DESTDIR || touch .failed
Patrick Georgi198d23c2012-12-08 08:02:44 +0100554
555 normalize_dirs
556
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100557 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200558) > ${BUILDDIRPREFIX}-expat/crossgcc-build.log 2>&1
559test -r ${BUILDDIRPREFIX}-expat/.failed && printf "${RED}failed${NC}\n" || \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100560 printf "${green}ok${NC}\n"
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200561test -r ${BUILDDIRPREFIX}-expat/.failed && exit 1
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100562fi
563
564
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200565if [ -f ${BUILDDIRPREFIX}-python/.success ]; then
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100566 printf "Skipping Python as it is already built\n"
Stefan Reinauer1200ec52011-11-01 22:39:41 +0100567elif [ $SKIPPYTHON -eq 1 ]; then
568 printf "Skipping Python (Python scripting not enabled)\n"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100569else
570printf "Building Python ${PYTHON_VERSION} ... "
571(
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200572 cd ${BUILDDIRPREFIX}-python
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100573 rm -f .failed
Patrick Georgi643c9e82011-11-04 21:30:49 +0100574 CC="$CC" CFLAGS="$HOSTCFLAGS" ../${PYTHON_DIR}/configure --prefix=$TARGETDIR \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100575 --target=${TARGETARCH} || touch .failed
576 $MAKE $JOBS || touch .failed
577 $MAKE install DESTDIR=$DESTDIR || touch .failed
Patrick Georgi198d23c2012-12-08 08:02:44 +0100578
579 normalize_dirs
580
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100581 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200582) > ${BUILDDIRPREFIX}-python/crossgcc-build.log 2>&1
583test -r ${BUILDDIRPREFIX}-python/.failed && printf "${RED}failed${NC}\n" || \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100584 printf "${green}ok${NC}\n"
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200585test -r ${BUILDDIRPREFIX}-python/.failed && exit 1
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100586fi
587
588
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200589if [ -f ${BUILDDIRPREFIX}-gdb/.success ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000590 printf "Skipping GDB as it is already built\n"
Peter Stugeceacd772011-06-09 04:54:16 +0200591elif [ $SKIPGDB -eq 1 ]; then
Stefan Reinauer1200ec52011-11-01 22:39:41 +0100592 printf "Skipping GDB (GDB support not enabled)\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000593else
594printf "Building GDB ${GDB_VERSION} ... "
595(
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200596 cd ${BUILDDIRPREFIX}-gdb
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100597 export PYTHONHOME=$DESTDIR$TARGETDIR
Stefan Reinauer074d9132009-09-26 16:43:17 +0000598 rm -f .failed
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100599 LDFLAGS="-Wl,-rpath,\$\$ORIGIN/../lib/ -L$DESTDIR$TARGETDIR/lib \
600 -lpthread -ldl -lutil" \
Patrick Georgi643c9e82011-11-04 21:30:49 +0100601 CC="$CC" CFLAGS="$HOSTCFLAGS -I$DESTDIR$TARGETDIR/include" \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100602 ../gdb-${GDB_VERSION}/configure --prefix=$TARGETDIR \
603 --target=${TARGETARCH} --disable-werror --disable-nls
Patrick Georgi73166c72010-04-14 20:42:42 +0000604 $MAKE $JOBS || touch .failed
Stefan Reinauer074d9132009-09-26 16:43:17 +0000605 $MAKE install DESTDIR=$DESTDIR || touch .failed
606 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200607) > ${BUILDDIRPREFIX}-gdb/crossgcc-build.log 2>&1
608test -r ${BUILDDIRPREFIX}-gdb/.failed && printf "${RED}failed${NC}\n" || \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100609 printf "${green}ok${NC}\n"
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200610test -r ${BUILDDIRPREFIX}-gdb/.failed && exit 1
Stefan Reinauer074d9132009-09-26 16:43:17 +0000611fi
612
Patrick Georgi6e61ad32012-05-12 23:19:30 +0200613if [ -f $IASL_DIR/source/compiler/.success ]; then
Marc Jones2aac3f62011-08-08 16:07:50 -0600614 printf "Skipping IASL as it is already built\n"
615else
616printf "Building IASL ${IASL_VERSION} ... "
617(
Idwer Vollering6b11c8b2012-11-15 21:14:36 +0100618 cd $IASL_DIR/generate/unix
Stefan Reinauer4266b922012-12-05 16:18:32 -0800619 rm -f .failed
Marc Jones2aac3f62011-08-08 16:07:50 -0600620 CFLAGS="$HOSTCFLAGS"
Stefan Reinauer0d2119d2013-07-10 14:27:56 -0700621 HOST="_LINUX"
622 test $UNAME = "Darwin" && HOST="_APPLE"
623 test $UNAME = "FreeBSD" && HOST="_FreeBSD"
624 test $UNAME = "Cygwin" && HOST="_CYGWIN"
625 HOST="$HOST" OPT_CFLAGS="-O -D_FORTIFY_SOURCE=2" CFLAGS="$CFLAGS" $MAKE CC="$CC" iasl || touch .failed
Stefan Reinauer4266b922012-12-05 16:18:32 -0800626 rm -f $DESTDIR$TARGETDIR/bin/iasl || touch .failed
Zheng Bao3c4bd912013-08-27 10:23:13 +0800627 cp bin/iasl $DESTDIR$TARGETDIR/bin || touch .failed
Stefan Reinauer4266b922012-12-05 16:18:32 -0800628 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi6e61ad32012-05-12 23:19:30 +0200629) > $IASL_DIR/source/compiler/crossgcc-build.log 2>&1
Stefan Reinauer4266b922012-12-05 16:18:32 -0800630test -r $IASL_DIR/generate/unix/.failed && printf "${RED}failed${NC}\n" || \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100631 printf "${green}ok${NC}\n"
Stefan Reinauer4266b922012-12-05 16:18:32 -0800632test -r $IASL_DIR/generate/unix/.failed && exit 1
Marc Jones2aac3f62011-08-08 16:07:50 -0600633fi
634
Zheng Bao30b895f2013-02-06 18:04:40 +0800635rm -f $DESTDIR$TARGETDIR/$0.commit.*
636cp $0 $DESTDIR$TARGETDIR/"$0.commit.`git describe`"
637
Stefan Reinauer074d9132009-09-26 16:43:17 +0000638if [ $SAVETEMPS -eq 0 ]; then
639 printf "Cleaning up... "
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200640 rm -rf ${GMP_DIR} ${BUILDDIRPREFIX}-gmp
641 rm -rf ${MPFR_DIR} ${BUILDDIRPREFIX}-mpfr
642 rm -rf ${MPC_DIR} ${BUILDDIRPREFIX}-mpc
643 rm -rf ${LIBELF_DIR} ${BUILDDIRPREFIX}-libelf
644 rm -rf ${BINUTILS_DIR} ${BUILDDIRPREFIX}-binutils
645 rm -rf ${GCC_DIR} ${BUILDDIRPREFIX}-gcc
646 rm -rf ${GDB_DIR} ${BUILDDIRPREFIX}-gdb
647 rm -rf ${EXPAT_DIR} ${BUILDDIRPREFIX}-expat
648 rm -rf ${PYTHON_DIR} ${BUILDDIRPREFIX}-python
Marc Jones2aac3f62011-08-08 16:07:50 -0600649 rm -rf ${IASL_DIR}
Stefan Reinauer074d9132009-09-26 16:43:17 +0000650 printf "${green}ok${NC}\n"
651else
652 printf "Leaving temporary files around... ${green}ok${NC}\n"
653fi
654
655printf "\n${green}You can now run your $TARGETARCH cross toolchain from $TARGETDIR.${NC}\n"
656
657